package com.yizhi.sign.application.vo;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@Api(tags = "ApiSignTimeVO", description = "签到详情VO")
public class ApiSignTimeVO {

    @ApiModelProperty(value = "主键id")
    private Long id;
    
    @ApiModelProperty(value = "有效签到时间区间（日期）左值，格式：yyyy-mm-dd HH:mm:ss")
    private String startTime;
    
    @ApiModelProperty(value = "有效签到时间区间（日期）右值，格式：yyyy-mm-dd HH:mm:ss")
    private String endTime;
    
    @ApiModelProperty(value = "签到地点")
    private String address;
    
    @ApiModelProperty(value = "签到范围")
    private String range;

    @ApiModelProperty(value = "签到积分")
    private Integer point;
    
    @ApiModelProperty(value = "培训项目id")
    private Long trainingProjectId;

    @ApiModelProperty(value = "培训项目名称")
    private String name;
    
    @ApiModelProperty(value = "签到状态")
    private Integer state;
    
	@ApiModelProperty(value = "签到时间")
	private String signDate;
	
    @ApiModelProperty(value = "经度")
    private Double longitude;
    
    @ApiModelProperty(value = "纬度")
    private Double latitude;
    
    @ApiModelProperty(value = "站点id")
    private Long siteId;
}
