package com.yizhi.sign.application.vo;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * <p>
 * 签到主体表，入口在培训项目
 * </p>
 *
 * @author fanchunhui123
 * @since 2018-03-07
 */
@Data
@Api(tags = "SignVO", description = "签到VO类，入口在培训项目")
public class SignVO {

    @ApiModelProperty(value = "主键id")
    private Long id;
    
    @ApiModelProperty(value = "学员ID")
    private Long accountId;

    @ApiModelProperty(value = "培训项目id")
    private Long trainingProjectId;

    @ApiModelProperty(value = "签到名称")
    private String name;

    @ApiModelProperty(value = "二维码，0：生成一张，1：按时间段生成多张")
    private Integer type;

    @ApiModelProperty(value = "是否开启补签（0：否，1：是），默认否")
    private Integer enableRetroactive;

    @ApiModelProperty(value = "是否消息提醒（分钟），0不提醒")
	private Integer remindTime;

    @ApiModelProperty(value = "是否开启邮件提醒（0：否，1：是），默认否。")
    private Integer enableRemindMail;
    
    @ApiModelProperty(value = "是否开启站内提醒（0：否，1：是），默认否。")
    private Integer enableRemindNote;
    
    @ApiModelProperty(value = "签到提醒模版ID。")
    private Long mailRemindTemplateId;
    

    @ApiModelProperty(value = "提醒内容")
    private String remindContent;

    @ApiModelProperty(value = "签到时间列表")
    private List<SignTimeVO> trSignTimeVOs;

    @ApiModelProperty(value = "签到途径")
    private Integer signType;

    @ApiModelProperty(value = "签到时间段")
    private Long signTimeId;
    
    @ApiModelProperty(value = "企业ID")
    Long companyId;
    
    @ApiModelProperty(value = "站点ID")
    Long siteId;
    
    @ApiModelProperty(value = "组织ID")
    Long orgId;
    
    @ApiModelProperty(value = "学员名")
    String accountName;

    @ApiModelProperty(value = "是否开启定位（0：否，1：是），默认否")
    private Integer enablePosition;
}
