package com.yizhi.sign.application.vo.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 签到时间段，一个 sign 对应多个 sign_time
 * </p>
 *
 * @author fanchunhui123
 * @since 2018-03-07
 */
@Data
@Api(tags = "TrSignTime", description = "签到时间段，一个 sign 对应多个 sign_time")
@TableName("tr_sign_time")
public class TrSignTime extends Model<TrSignTime> {

    private static final long serialVersionUID = 1L;


@ApiModelProperty(value = "主键id")
	private Long id;

@ApiModelProperty(value = "冗余项目id")
	@TableField("training_project_id")
	private Long trainingProjectId;

@ApiModelProperty(value = "签名id")
	@TableField("sign_id")
	private Long signId;

@ApiModelProperty(value = "有效签到时间区间左值")
	@TableField("start_time")
	private Date startTime;

@ApiModelProperty(value = "有效签到时间区间右值")
	@TableField("end_time")
	private Date endTime;

@ApiModelProperty(value = "是否停用（0：否，1：是） 默认0")
	private Integer deleted;

@ApiModelProperty(value = "创建者id")
	@TableField(value = "create_by_id", fill = FieldFill.INSERT)
	private Long createById;

@ApiModelProperty(value = "创建者名称")
	@TableField(value = "create_by_name", fill = FieldFill.INSERT)
	private String createByName;

@ApiModelProperty(value = "创建时间")
	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

@ApiModelProperty(value = "更新者id")
	@TableField(value = "update_by_id", fill = FieldFill.INSERT)
	private Long updateById;

@ApiModelProperty(value = "修改者名称")
	@TableField(value = "update_by_name", fill = FieldFill.INSERT)
	private String updateByName;

@ApiModelProperty(value = "修改时间")
	@TableField(value = "update_time", fill = FieldFill.INSERT)
	private Date updateTime;

@ApiModelProperty(value = "是否开启定位（0：否，1：是），默认否")
@TableField("enable_position")
	private Integer enablePosition;

@ApiModelProperty(value = "签到地点")
@TableField("address")
	private String address;

@ApiModelProperty(value = "签到范围")
@TableField("range")
	private String range;

@ApiModelProperty(value = "签到积分")
@TableField("point")
	private Integer point;

@ApiModelProperty(value = "邀请码")
@TableField("code")
	private String code;

@ApiModelProperty(value = "经度")
@TableField("longitude")
	private Double longitude;

@ApiModelProperty(value = "纬度")
@TableField("latitude")
	private Double latitude;
	@Override
	protected Serializable pkVal() {
		return this.id;
	}

}
