package com.yizhi.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.application.domain.StatisticsSign;
import com.yizhi.application.domain.StatisticsSignLearn;
import com.yizhi.application.domain.TrSign;

import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;
import java.util.Map;

public interface StatisticsSignMapper extends BaseMapper<StatisticsSign> {
    List<StatisticsSign> statisticsSignPage(@Param("projectId") Long projectId,
                                            @Param("startDate") String startDate,
                                            @Param("endDate") String endDate,
                                            @Param("signCompanyId") Long signCompanyId,
                                            @Param("signOrgIds") List<Long> signOrgIds,
                                            @Param("signSiteId")Long signSiteId,
                                            @Param("kwd") String kwd,
                                            Page<StatisticsSign> page);
    Integer statisticsSignCount(@Param("projectId") Long projectId,
                                @Param("startDate") String startDate,
                                @Param("endDate") String endDate,
                                @Param("signCompanyId") Long signCompanyId,
                                @Param("signOrgIds") List<Long> signOrgIds,
                                @Param("signSiteId")Long signSiteId);

    List<StatisticsSign> statisticsSignView(
			@Param("signId") Long signId,
			@Param("signTimeId") Long signTimeId,
			@Param("startDate") String statrDate,
			@Param("endDate") String endDate,
			@Param("orgNameOrCode") String orgNameOrCode,
			@Param("accountName") String accountName,
			Page<StatisticsSign> page);
    Integer statisticsSignViewCount(
			@Param("signId") Long signId,
    		@Param("signTimeId") Long signTimeId,
                                    @Param("startDate") String statrDate,
                                    @Param("endDate") String endDate,
                                    @Param("orgNameOrCode") String orgNameOrCode,
                                    @Param("accountName") String accountName);

    List<StatisticsSign> chartGroup(@Param("projectId") Long trainnigProjectId,
                                    @Param("startDate") String startDate,
                                    @Param("endDate") String endDate,
                                    @Param("signCompanyId") Long signCompanyId,
                                    @Param("signOrgIds") List<Long> signOrgIds,
                                    @Param("signSiteId")Long signSiteId);
	Date selectMaxDate();
	Date selectRecordMinTime();
	List<TrSign> getAllResearchs(@Param("startDate") String startDate, @Param("endDate") String endDate);
	void deleteRecordeByDate(@Param("currentDate") String currentDate);
	
	/**
	 * 批量插入
	 * @param researchId
	 * @param currentDate
	 * @return 
	 */
	int insertAccountLearn(@Param("researchId")Long researchId, @Param("currentDate")String currentDate);
	
	/**
	 * 获取添加的签到信息
	 * @param researchId  
	 * @param currentDate 
	 * @return  
	 */
	List<StatisticsSignLearn> selectAccountLearn(@Param("researchId")Long researchId, @Param("currentDate")String currentDate);
	
	Integer selectEmptyCourseLearnCount(@Param("researchId")Long researchId);
	void deleteEmptyAccountLearn();
	Integer selectEmptyCourseAccountLearnCount(@Param("researchId")Long researchId, @Param("researchId") Long accountId);

	List<Long> getAllRelationId(@Param("trainingProjectId")Long param);

	/**
	 * 查找学员有没有学了该调研
	 * @param signId
	 * @return
	 */
	@MapKey("accountId")
	Map<Long, Long> selectAccountLearnByResearchId(@Param("signId") Long signId);

	/**
	 * 按部门纬度统计数据量会很大,影响效率.对其进行拆分，按部门统计从此表中查询
	 */
	void insertStatisticsResearchToGroupFind();

	void deleteStatisticsResearchToGroupFind();

	/**
	 * 调研信息直接从statistics_research_metadata表中查询效率很慢，对其进行拆分.按调研和用户统计的查询条件从此获取
	 */
	void insertStatisticsResearchToAccountGroupFind();

	void deleteStatisticsResearchToAccountGroupFind();
	
	/**
	 * 删除应参加人数统计表
	 */
	void deleteStatisticsAccountCanCount();
	
	/**
	 * 添加应参加人数统计表
	 */
	void insertStatisticsAccountCanCount();


	/**
	 * 报表服务获取签到记录
	 * @param signTimeId
	 * @param startDate
	 * @param endDate
	 * @return
	 */
	List<StatisticsSignLearn> getRecords(@Param("signTimeId") Long signTimeId,@Param("startDate") String startDate,@Param("endDate") String endDate);
}
