package com.yizhi.application.service;

import com.yizhi.application.domain.TrSignRecord;
import com.yizhi.sign.application.vo.ExportSignRecordVO;

import com.baomidou.mybatisplus.service.IService;

import java.util.List;

/**
 * <p>
 * 签到记录表 服务类
 * </p>
 *
 * @author fanchunhui123
 * @since 2018-03-07
 */
public interface SignRecordService extends IService<TrSignRecord> {

    /**
     * 我的签到总数量
     *
     * @param accountId 学员ID
     * @return
     */
    Integer selectCountByAccountId(Long accountId);


    /**
     * 获取签到完成数量( PC 端  学习统计签到 完成数量)
     *
     * @param trainingProjectId 培训项目ID
     * @return
     */
    Integer selectCountByTrainingProjectId(Long trainingProjectId, Long accountId);

    /**
     * 签到记录导出
     *
     * @param accountId
     * @param isAdmin
     * @param siteId
     * @param trainingProjectId
     * @return
     */
    List<ExportSignRecordVO> exportSignRecord(Long accountId, boolean isAdmin, Long siteId, Long trainingProjectId);

    boolean insertSignRecordList(List<TrSignRecord> signRecordList);
}
