package com.yizhi.application.service.impl;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.application.domain.StatisticsSign;
import com.yizhi.application.domain.StatisticsSignLearn;
import com.yizhi.application.mapper.StatisticsSignMapper;
import com.yizhi.application.service.StatisticsSignService;
import com.google.common.collect.Lists;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

@Service
public class StitisticsSignServiceImpl extends ServiceImpl<StatisticsSignMapper, StatisticsSign> implements StatisticsSignService {

    @Autowired
    private StatisticsSignMapper statisticsSignMapper;

    private SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");

    @Override
    public Page<com.yizhi.sign.application.vo.domain.StatisticsSign> statisticsSignPage(Long projectId, String kwd, String startDate, String endDate, Long signCompanyId, List<Long> signOrgIds, Long signSiteId, Integer pageNo, Integer pageSize) {

        Page<StatisticsSign> page = new Page<>(pageNo, pageSize);
        Page<com.yizhi.sign.application.vo.domain.StatisticsSign> page1 = new Page<>(pageNo, pageSize);
        List<StatisticsSign> list = statisticsSignMapper.statisticsSignPage(projectId, startDate, endDate, signCompanyId, signOrgIds, signSiteId, kwd, page);
        List<com.yizhi.sign.application.vo.domain.StatisticsSign> result = Lists.newArrayListWithCapacity(pageSize);
        Integer NotSigncount = 0;
        for (StatisticsSign statisticsSign : list) {
            NotSigncount = statisticsSign.getCanStateCount() - statisticsSign.getJoinStateCount();
            statisticsSign.setNotSignCount(NotSigncount);
            com.yizhi.sign.application.vo.domain.StatisticsSign statisticsSign1 = new com.yizhi.sign.application.vo.domain.StatisticsSign();
            BeanUtils.copyProperties(statisticsSign,statisticsSign1);
            result.add(statisticsSign1);
        }
        if (!CollectionUtils.isEmpty(result)){
            BeanUtils.copyProperties(page,page1);
            page1.setRecords(result);
        }
        return page1;
    }


    @Override
    public Page<StatisticsSign> statisticsSignView(Long signId, Long signTimeId, String startDate, String endDate, String orgNameOrCode, String accountName, Integer pageNo, Integer pageSize) {
        if (accountName == null || accountName.equals("")) {
            accountName = null;
        }
        if (orgNameOrCode == null || orgNameOrCode.equals("")) {
            orgNameOrCode = null;
        }
        Page<StatisticsSign> page = new Page<StatisticsSign>(pageNo, pageSize);
        List<StatisticsSign> list = statisticsSignMapper.statisticsSignView(signId, signTimeId, startDate, endDate, orgNameOrCode, accountName, page);
        if (!CollectionUtils.isEmpty(list)) {
            page.setRecords(list);
        }
        return page;
    }

    @Override
    public List<StatisticsSign> chartGroup(Long trainningProjectId, String startDate, String endDate, Long signCompanyId, List<Long> signOrgIds, Long signSiteId) {
        List<StatisticsSign> listAllRecord = new ArrayList<StatisticsSign>();
        ;
        try {
            List<StatisticsSign> list = statisticsSignMapper.chartGroup(trainningProjectId, startDate, endDate, signCompanyId, signOrgIds, signSiteId);
            Date startDate1;
            Date endDate1;
            int num = 0;
            String oldDate;
            startDate1 = simpleDateFormat.parse(startDate);
            endDate1 = simpleDateFormat.parse(endDate);
            num = (int) ((endDate1.getTime() - startDate1.getTime()) / (1000 * 3600 * 24));
            Date updateDate = startDate1;
            String updateDateValue = simpleDateFormat.format(updateDate);
            Boolean isTrue = false;
            StatisticsSign rsccv;
            int j = 0;
            for (int i = 0; i <= num; i++) {
                if (list != null && list.size() > 0) {
                    if (j < list.size()) {
                        rsccv = list.get(j);
                        if (null == rsccv.getSignTime()) {
                            continue;
                        }
                        if (simpleDateFormat.format(rsccv.getSignTime()).equals(updateDateValue)) {
                            j = j + 1;
                            listAllRecord.add(rsccv);
                            isTrue = true;
                        } else {
                            isTrue = false;
                        }
                    }
                }
                if (!isTrue) {
                    rsccv = new StatisticsSign();
                    rsccv.setSignTime(updateDate);
                    rsccv.setJoinStateCount(0);
                    rsccv.setCanStateCount(0);
                    listAllRecord.add(rsccv);

                }
                Calendar c = Calendar.getInstance();
                c.setTime(updateDate);
                c.add(Calendar.DAY_OF_MONTH, 1); // 利用Calendar 实现 Date日期+1天
                updateDate = c.getTime();
                updateDateValue = simpleDateFormat.format(updateDate);
                isTrue = false;

            }
        } catch (ParseException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return listAllRecord;
    }

    @Override
    public List<StatisticsSignLearn> insertAccountLearn(Long researchId, String currentDate) {
        int count = statisticsSignMapper.insertAccountLearn(researchId, currentDate);
        if (count == 0) {
            return null;
        }

        return statisticsSignMapper.selectAccountLearn(researchId, currentDate);
    }

    @Override
    public Integer statisticsSignPageCount(Long projectId, String startDate, String endDate, Long signCompanyId, List<Long> signOrgIds, Long signSiteId) {
        return statisticsSignMapper.statisticsSignCount(projectId, startDate, endDate, signCompanyId, signOrgIds, signSiteId);
    }

    @Override
    public List<StatisticsSign> statisticsSignList(Long projectId, String startDate, String endDate, Long signCompanyId, List<Long> signOrgIds, Long signSiteId, Integer pageNo, Integer pageSize) {
        Page<StatisticsSign> page = new Page<StatisticsSign>(pageNo, pageSize);
        List<StatisticsSign> list = statisticsSignMapper.statisticsSignPage(projectId, startDate, endDate, signCompanyId, signOrgIds, signSiteId, null, page);
        return list;
    }

    @Override
    public Integer statisticsSignViewCount(Long id, Long trainningProjectId, String startDate, String endDate, String orgNameOrCode, String accountName) {
        if (accountName == null || accountName.equals("")) {
            accountName = null;
        }
        if (orgNameOrCode == null || orgNameOrCode.equals("")) {
            orgNameOrCode = null;
        }
        return statisticsSignMapper.statisticsSignViewCount(id, trainningProjectId, startDate, endDate, orgNameOrCode, accountName);
    }

    @Override
    public List<StatisticsSign> statisticsSignViewList(Long id, Long trainningProjectId, String startDate, String endDate, String orgNameOrCode, String accountName, Integer pageNo, Integer pageSize) {
        if (accountName == null || accountName.equals("")) {
            accountName = null;
        }
        if (orgNameOrCode == null || orgNameOrCode.equals("")) {
            orgNameOrCode = null;
        }
        Page<StatisticsSign> page = new Page<StatisticsSign>(pageNo, pageSize);
        List<StatisticsSign> list = statisticsSignMapper.statisticsSignView(id, trainningProjectId, startDate, endDate, orgNameOrCode, accountName, page);
        return list;
    }
}
